use GD;
$infile="bovine_all.mmr.sorted.txt";
$field_height=1;
$field_width=25;

# check INFILE and create image
open(INFILE,$infile)||die print"\nCannot open $infile!\t$!\n\n";
$probes=<INFILE>;
@probes=split("\t",$probes);
$probes=@probes-1;
$clusters=0;
while(<INFILE>)
	{
	$clusters++;
	}
close INFILE;
$image=new GD::Image($field_width*$probes,$field_height*$clusters+20);
$white=$image->colorAllocate(255,255,255);
foreach$p(0..100)
	{
	$shades[$p]=$image->colorAllocate(int(255-($p/100*200)),180-$p,int(($p/100*150)));	# blue -orange
	#$shades[$p]=$image->colorAllocate(int(255-($p/100*255)),60,int(($p/100*255)));	# blue - red
	#$shades[$p]=$image->colorAllocate(60,int(255-($p/100*255)),int(255-($p/100*255)));	# black - lightblue
	#$shades[$p]=$image->colorAllocate(int(255-($p/100*255)),60,int(255-($p/100*255)));	# black - purple
	#$shades[$p]=$image->colorAllocate(int(255-($p/100*255)),int(($p/100*255)),60);	# green - red
	#$shades[$p]=$image->colorAllocate(60,int(255-($p/100*255)),60);	# black - green
	#$shades[$p]=$image->colorAllocate(60,100-$p,int(255-($p/100*255)));	# black - blue
	}


open(INFILE,$infile)||die print"\nCannot open $infile!\t$!\n\n";
$head=<INFILE>;
$y_factor=-1;
while(<INFILE>)
	{
	$y_factor++;
	$_=~s/\s*$//;
	@values=split("\t",$_);
	
	# save maximum value
	$max=0;
	foreach$v(1..@values)
		{
		if($values[$v]>$max)
			{
			$max=$values[$v];
			}
		}
	
	# print fields
	$x_factor=-1;
	foreach$v(1..@values)
		{
		$x_factor++;
		foreach(0..$field_height-1)
			{
			$image->line($x_factor*$field_width,($y_factor*$field_height)+$_,($x_factor*$field_width)+$field_width,($y_factor*$field_height)+$_,$shades[100-int(($values[$v]/$max)*100)]);
			}
		}
	}
close INFILE;

# print legend
foreach$i(0..100)
	{
	$image->line($i,$field_height*$clusters+10,$i,$field_height*$clusters+20,$shades[100-$i]);
	}
$image->string(gdTinyFont,2,$field_height*$clusters+11,"low",$shades[0]);
$image->string(gdTinyFont,80,$field_height*$clusters+11,"high",$shades[100]);

# save IMAGE
open(IMAGE,">$infile.png")||die print"\nCould not create output image!\n$!\n\n";
binmode IMAGE;
print IMAGE $image->png;
close IMAGE;